Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2269)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2270)
@@ -955,84 +966,159 @@
 
     IF (  .NOT.  constant_flux_layer )  THEN
-       message_string = 'lsm requires '//                                   &
+       message_string = 'lsm requires '//                                      &
                         'constant_flux_layer = .T.'
        CALL message( 'check_parameters', 'PA0400', 1, 2, 0, 6, 0 )
     ENDIF
 
-    IF ( ( veg_type == 14  .OR.  veg_type == 15 ) .AND.                     &
-           most_method == 'lookup' )  THEN
-        WRITE( message_string, * ) 'veg_type = ', veg_type, ' is not ',     &
-                                   'allowed in combination with ',          &
-                                   'most_method = ', most_method
-       CALL message( 'check_parameters', 'PA0417', 1, 2, 0, 6, 0 )
+    IF ( TRIM( surface_type ) == 'vegetation' )  THEN
+    
+       IF ( vegetation_type == 0 )  THEN
+          IF ( min_canopy_resistance == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user defined)'//              &
+                              'requires setting of min_canopy_resistance'//       &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( leaf_area_index == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of leaf_area_index'//             &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( vegetation_coverage == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of vegetation_coverage'//         &
+                              '/= 9999999.9'
+                CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( canopy_resistance_coefficient == 9999999.9_wp)  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of'//                             &
+                              'canopy_resistance_coefficient /= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( lambda_surface_stable == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of lambda_surface_stable'//       &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of lambda_surface_unstable'//     &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of f_shortwave_incoming'//        &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( z0_vegetation == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of z0_vegetation'//               &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( z0h_vegetation == 9999999.9_wp )  THEN
+             message_string = 'vegetation_type = 0 (user_defined)'//              &
+                              'requires setting of z0h_vegetation'//              &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+       ENDIF
+       
     ENDIF
-
-    IF ( veg_type == 0 )  THEN
-       IF ( min_canopy_resistance == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user defined)'//                  &
-                           'requires setting of min_canopy_resistance'//    &
-                           '/= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( leaf_area_index == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of leaf_area_index'//          &
-                           '/= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( vegetation_coverage == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of vegetation_coverage'//      &
-                           '/= 9999999.9'
-             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( canopy_resistance_coefficient == 9999999.9_wp)  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of'//                          &
-                           'canopy_resistance_coefficient /= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( lambda_surface_stable == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of lambda_surface_stable'//    &
-                           '/= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of lambda_surface_unstable'//  &
-                           '/= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of f_shortwave_incoming'//     &
-                           '/= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( z0_eb == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of z0_eb'//                    &
-                           '/= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( z0h_eb == 9999999.9_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of z0h_eb'//                   &
-                           '/= 9999999.9'
-          CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-       ENDIF
-
-
+    
+    IF ( TRIM( surface_type ) == 'water' )  THEN
+
+       IF ( TRIM( most_method ) == 'lookup' )  THEN    
+          WRITE( message_string, * ) 'surface_type = ', surface_type,          &
+                                     ' is not allowed in combination with ',   &
+                                     'most_method = ', most_method
+          CALL message( 'check_parameters', 'PA0417', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       IF ( water_type == 0 )  THEN  
+       
+          IF ( z0_water == 9999999.9_wp )  THEN
+             message_string = 'water_type = 0 (user_defined)'//                &
+                              'requires setting of z0_water'//                 &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0415', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( z0h_water == 9999999.9_wp )  THEN
+             message_string = 'water_type = 0 (user_defined)'//                &
+                              'requires setting of z0h_water'//                &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0392', 1, 2, 0, 6, 0 )
+          ENDIF
+          
+          IF ( water_temperature == 9999999.9_wp )  THEN
+             message_string = 'water_type = 0 (user_defined)'//                &
+                              'requires setting of water_temperature'//        &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0379', 1, 2, 0, 6, 0 )
+          ENDIF       
+          
+       ENDIF
+       
     ENDIF
-
+    
+    
+     
+    IF ( TRIM( surface_type ) == 'pavement' )  THEN
+
+       IF ( pavement_type == 0 )  THEN  
+       
+          IF ( z0_pavement == 9999999.9_wp )  THEN
+             message_string = 'pavement_type = 0 (user_defined)'//             &
+                              'requires setting of z0_pavement'//              &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0352', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( z0h_pavement == 9999999.9_wp )  THEN
+             message_string = 'pavement_type = 0 (user_defined)'//             &
+                              'requires setting of z0h_pavement'//             &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0353', 1, 2, 0, 6, 0 )
+          ENDIF
+
+           IF ( pavement_depth == 9999999.9_wp )  THEN
+             message_string = 'pavement_type = 0 (user_defined)'//             &
+                              'requires setting of pavement_depth'//           &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0341', 1, 2, 0, 6, 0 )
+          ENDIF         
+          
+           IF ( pavement_heat_conduct == 9999999.9_wp )  THEN
+             message_string = 'pavement_type = 0 (user_defined)'//             &
+                              'requires setting of pavement_heat_conduct'//    &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0342', 1, 2, 0, 6, 0 )
+          ENDIF 
+          
+           IF ( pavement_heat_capacity == 9999999.9_wp )  THEN
+             message_string = 'pavement_type = 0 (user_defined)'//             &
+                              'requires setting of pavement_heat_capacity'//   &
+                              '/= 9999999.9'
+             CALL message( 'check_parameters', 'PA0139', 1, 2, 0, 6, 0 )
+          ENDIF 
+
+       ENDIF 
+    
+    ENDIF
+    
     IF ( soil_type == 0 )  THEN
 
@@ -1094,22 +1180,4 @@
 
     ENDIF
-!
-!-- Check for proper setting of soil moisture, must not be larger than its 
-!-- saturation value. 
-    DO  k = nzb_soil, nzt_soil
-       IF ( soil_moisture(k) > m_soil_pars(0,soil_type) )  THEN 
-          message_string = 'soil_moisture must not exceed its saturation' // &
-                           ' value'
-          CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDDO
-
-    IF (  .NOT.  radiation )  THEN
-       message_string = 'lsm requires '//                                   &
-                        'radiation = .T.'
-       CALL message( 'check_parameters', 'PA0400', 1, 2, 0, 6, 0 )
-    ENDIF
-       
-
 
 !
@@ -1117,5 +1185,5 @@
 !-- root fraction is prescribed
     nzb_soil = 0
-    nzt_soil = 0
+    nzt_soil = -1
     IF ( ALL( zs == 9999999.9_wp ) )  THEN
        nzt_soil = 7
@@ -1136,13 +1204,24 @@
     ENDIF
 
-    IF ( veg_type == 0 )  THEN
+    IF ( vegetation_type == 0 )  THEN
        IF ( SUM( root_fraction(nzb_soil:nzt_soil) ) /= 1.0_wp )  THEN
-          message_string = 'veg_type = 0 (user_defined)'//                  &
-                           'requires setting of root_fraction'//            &
+          message_string = 'vegetation_type = 0 (user_defined)'//              &
+                           'requires setting of root_fraction'//               &
                            '/= 9999999.9 and SUM(root_fraction) = 1'
           CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
        ENDIF
-    ENDIF
+    ENDIF    
     
+    
+!
+!-- Check for proper setting of soil moisture, must not be larger than its 
+!-- saturation value. 
+    DO  k = nzb_soil, nzt_soil
+       IF ( soil_moisture(k) > soil_pars(4,soil_type) )  THEN 
+          message_string = 'soil_moisture must not exceed its saturation' // &
+                           ' value'
+          CALL message( 'check_parameters', 'PA0403', 1, 2, 0, 6, 0 )
+       ENDIF
+    ENDDO
   
  END SUBROUTINE lsm_check_parameters
@@ -1155,4 +1234,6 @@
  SUBROUTINE lsm_energy_balance( horizontal, l )
 
+ 
+    USE pegrid
 
     IMPLICIT NONE
@@ -1183,11 +1264,11 @@
                 coef_1,      & !< coef. for prognostic equation
                 coef_2,      & !< coef. for prognostic equation
-                f_qsws,      & !< factor for qsws_eb
-                f_qsws_veg,  & !< factor for qsws_veg_eb
-                f_qsws_soil, & !< factor for qsws_soil_eb
-                f_qsws_liq,  & !< factor for qsws_liq_eb
-                f_shf,       & !< factor for shf_eb
-                lambda_surface, & !< Current value of lambda_surface
-                m_liq_eb_max,   & !< maxmimum value of the liq. water reservoir
+                f_qsws,      & !< factor for qsws
+                f_qsws_veg,  & !< factor for qsws_veg
+                f_qsws_soil, & !< factor for qsws_soil
+                f_qsws_liq,  & !< factor for qsws_liq
+                f_shf,       & !< factor for shf
+                lambda_surface, & !< Current value of lambda_surface (W/m2/K)
+                m_liq_max,   & !< maxmimum value of the liq. water reservoir
                 pt1,         & !< potential temperature at first grid level
                 qv1            !< specific humidity at first grid level
@@ -1196,7 +1277,7 @@
     TYPE(surf_type_lsm), POINTER ::  surf_t_surface_p
     TYPE(surf_type_lsm), POINTER ::  surf_tt_surface_m
-    TYPE(surf_type_lsm), POINTER ::  surf_m_liq_eb
-    TYPE(surf_type_lsm), POINTER ::  surf_m_liq_eb_p
-    TYPE(surf_type_lsm), POINTER ::  surf_tm_liq_eb_m
+    TYPE(surf_type_lsm), POINTER ::  surf_m_liq
+    TYPE(surf_type_lsm), POINTER ::  surf_m_liq_p
+    TYPE(surf_type_lsm), POINTER ::  surf_tm_liq_m
 
     TYPE(surf_type_lsm), POINTER ::  surf_m_soil
@@ -1211,7 +1292,7 @@
        surf_t_surface_p  => t_surface_h_p
        surf_tt_surface_m => tt_surface_h_m
-       surf_m_liq_eb     => m_liq_eb_h
-       surf_m_liq_eb_p   => m_liq_eb_h_p
-       surf_tm_liq_eb_m  => tm_liq_eb_h_m
+       surf_m_liq     => m_liq_h
+       surf_m_liq_p   => m_liq_h_p
+       surf_tm_liq_m  => tm_liq_h_m
        surf_m_soil       => m_soil_h
        surf_t_soil       => t_soil_h
@@ -1226,7 +1307,7 @@
        surf_t_surface_p  => t_surface_v_p(l)
        surf_tt_surface_m => tt_surface_v_m(l)
-       surf_m_liq_eb     => m_liq_eb_v(l)
-       surf_m_liq_eb_p   => m_liq_eb_v_p(l)
-       surf_tm_liq_eb_m  => tm_liq_eb_v_m(l)
+       surf_m_liq     => m_liq_v(l)
+       surf_m_liq_p   => m_liq_v_p(l)
+       surf_tm_liq_m  => tm_liq_v_m(l)
        surf_m_soil       => m_soil_v(l)
        surf_t_soil       => t_soil_v(l)
@@ -1263,20 +1344,41 @@
 !--    radiation can be obtained at respective height level
        k_rad = MERGE( 0, k + k_off, radiation_scheme /= 'rrtmg' )
-!
-!--    Set lambda_surface according to stratification between skin layer and soil
-       IF (  .NOT.  surf%pave_surface(m) )  THEN
-
-          c_surface_tmp = c_surface
-
-          IF ( surf_t_surface%var_1d(m) >= surf_t_soil%var_2d(nzb_soil,m))  THEN
-             lambda_surface = surf%lambda_surface_s(m)
-          ELSE
-             lambda_surface = surf%lambda_surface_u(m)
-          ENDIF
+
+!
+!--    Define heat conductivity between surface and soil depending on surface
+!--    type. For vegetation, a skin layer parameterization is used. For bare
+!--    soil and pavements, no skin layer is applied. In these cases, the
+!--    temperature is assumed to be constant between the surface and the first
+!--    soil layer. The heat conductivity is then derived from the soil/
+!--    pavement properties. For water surfaces, the conductivity is already set
+!--    to 1E10.
+!--    Moreover, the heat capacity is set. For bare soil the heat capacity is
+!--    the capacity of the uppermost soil layer
+       IF ( surf%lambda_surface_s(m) == 0.0_wp )  THEN 
+       
+          lambda_h_sat = lambda_h_sm**(1.0_wp - surf%m_sat(nzb_soil,m)) *      &
+                         lambda_h_water ** surf_m_soil%var_2d(nzb_soil,m)
+                         
+          ke = 1.0_wp + LOG10( MAX( 0.1_wp, surf_m_soil%var_2d(nzb_soil,m) /   &
+                                                     surf%m_sat(nzb_soil,m) ) )                   
+                         
+          lambda_surface = (ke * (lambda_h_sat - lambda_h_dry) + lambda_h_dry )&
+                           * ddz_soil_layer(nzb_soil) * 2.0_wp
+          
+          c_surface_tmp = (rho_c_soil * ( 1.0_wp - surf%m_sat(nzb_soil,m) )    &
+                           + rho_c_water * surf_m_soil%var_2d(nzb_soil,m) )    &
+                           * dz_soil_layer(nzb_soil) * 0.25_wp               
+
+       ELSEIF ( surf_t_surface%var_1d(m) >= surf_t_soil%var_2d(nzb_soil,m)) &
+       THEN
+
+          lambda_surface = surf%lambda_surface_s(m)
+          c_surface_tmp = surf%c_surface(m) 
+          
        ELSE
 
-          c_surface_tmp = pave_heat_capacity * dz_soil(nzb_soil) * 0.5_wp
-          lambda_surface = pave_heat_conductivity * ddz_soil(nzb_soil)
-
+          lambda_surface = surf%lambda_surface_u(m)
+          c_surface_tmp = surf%c_surface(m) 
+          
        ENDIF
 
@@ -1333,12 +1435,16 @@
        DO  ks = nzb_soil, nzt_soil
            m_total = m_total + surf%root_fr(ks,m)                              &
-                     * MAX( surf_m_soil%var_2d(ks,m), surf%m_wilt(m) )
+                     * MAX( surf_m_soil%var_2d(ks,m), surf%m_wilt(ks,m) )
        ENDDO 
 
-       IF ( m_total > surf%m_wilt(m)  .AND.                                    &
-            m_total < surf%m_fc(m) )  THEN
-          f2 = ( m_total - surf%m_wilt(m) ) /                                  &
-               ( surf%m_fc(m) - surf%m_wilt(m) )
-       ELSEIF ( m_total >= surf%m_fc(m) )  THEN
+!
+!--    The calculation of f2 is based on only one wilting point value for all
+!--    soil layers. The value at k=nzb_soil is used here as a proxy but might
+!--    need refinement in the future.
+       IF ( m_total > surf%m_wilt(nzb_soil,m)  .AND.                           &
+            m_total < surf%m_fc(nzb_soil,m) )  THEN
+          f2 = ( m_total - surf%m_wilt(nzb_soil,m) ) /                         &
+               ( surf%m_fc(nzb_soil,m) - surf%m_wilt(nzb_soil,m) )
+       ELSEIF ( m_total >= surf%m_fc(nzb_soil,m) )  THEN
           f2 = 1.0_wp
        ELSE
@@ -1366,19 +1472,15 @@
                               ( surf%lai(m) * f1 * f2 * f3 + 1.0E-20_wp )
 !
-!--    Third step: calculate bare soil resistance r_soil. The Clapp & 
-!--    Hornberger parametrization does not consider c_veg.
-       IF ( surf%soil_type_2d(m) /= 7 )  THEN
-          m_min = surf%c_veg(m) * surf%m_wilt(m) +                             &
-                         ( 1.0_wp - surf%c_veg(m) ) * surf%m_res(m)
-       ELSE
-          m_min = surf%m_wilt(m)
-       ENDIF
-
-       f2 = ( surf_m_soil%var_2d(nzb_soil,m) - m_min ) / ( surf%m_fc(m) - m_min )
+!--    Third step: calculate bare soil resistance r_soil.
+       m_min = surf%c_veg(m) * surf%m_wilt(nzb_soil,m) +                       &
+                         ( 1.0_wp - surf%c_veg(m) ) * surf%m_res(nzb_soil,m)
+
+
+       f2 = ( surf_m_soil%var_2d(nzb_soil,m) - m_min ) / ( surf%m_fc(nzb_soil,m) - m_min )
        f2 = MAX( f2, 1.0E-20_wp )
        f2 = MIN( f2, 1.0_wp     )
 
        surf%r_soil(m) = surf%r_soil_min(m) / f2
-
+       
 !
 !--    Calculate the maximum possible liquid water amount on plants and
@@ -1388,11 +1490,11 @@
 !--    Noilhan & Planton (1989), while the ECMWF formulation is used for
 !--    vegetated surfaces and bare soils.
-       IF ( surf%pave_surface(m) )  THEN
-          m_liq_eb_max = m_max_depth * 5.0_wp
-          surf%c_liq(m) = MIN( 1.0_wp, ( surf_m_liq_eb%var_1d(m) / m_liq_eb_max)**0.67 )
+       IF ( surf%pavement_surface(m) )  THEN
+          m_liq_max = m_max_depth * 5.0_wp
+          surf%c_liq(m) = MIN( 1.0_wp, ( surf_m_liq%var_1d(m) / m_liq_max)**0.67 )
        ELSE
-          m_liq_eb_max = m_max_depth * ( surf%c_veg(m) * surf%lai(m)&
-                            + ( 1.0_wp - surf%c_veg(m) ) )
-          surf%c_liq(m) = MIN( 1.0_wp, surf_m_liq_eb%var_1d(m) / m_liq_eb_max )
+          m_liq_max = m_max_depth * ( surf%c_veg(m) * surf%lai(m)              &
+                      + ( 1.0_wp - surf%c_veg(m) ) )
+          surf%c_liq(m) = MIN( 1.0_wp, surf_m_liq%var_1d(m) / m_liq_max )
        ENDIF
 !
@@ -1415,5 +1517,5 @@
           f_qsws_soil = 0.0_wp
           f_qsws_liq  = rho_lv / surf%r_a(m)
-       ELSEIF ( surf%pave_surface (m) )  THEN
+       ELSEIF ( surf%pavement_surface (m) )  THEN
           f_qsws_veg  = 0.0_wp
           f_qsws_soil = 0.0_wp
@@ -1428,10 +1530,4 @@
                               surf%r_a(m)
        ENDIF
-!
-!--       If soil moisture is below wilting point, plants do no longer
-!--       transpirate.
-!           IF ( m_soil(k,j,i) < m_wilt(j,i) )  THEN
-!              f_qsws_veg = 0.0_wp
-!           ENDIF
 
        f_shf  = rho_cp / surf%r_a(m)
@@ -1535,27 +1631,24 @@
                      ( surf_t_surface_p%var_1d(m) - surf_t_surface%var_1d(m) )
 
-       surf%ghf_eb(m) = lambda_surface * ( surf_t_surface_p%var_1d(m)          &
+       surf%ghf(m) = lambda_surface * ( surf_t_surface_p%var_1d(m)          &
                                              - surf_t_soil%var_2d(nzb_soil,m) )
 
-       surf%shf_eb(m) = - f_shf * ( pt1 - surf%pt_surface(m) )
-
-       surf%shf(m) = surf%shf_eb(m) / rho_cp
+       surf%shf(m) = - f_shf * ( pt1 - surf%pt_surface(m) ) / cp
+
 
        IF ( humidity )  THEN
-          surf%qsws_eb(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt                  &
+          surf%qsws(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt                  &
                           * surf_t_surface%var_1d(m) - dq_s_dt *               &
                             surf_t_surface_p%var_1d(m) )
 
-          surf%qsws(m) = surf%qsws_eb(m) / rho_lv
-
-          surf%qsws_veg_eb(m)  = - f_qsws_veg  * ( qv1 - q_s                   &
+          surf%qsws_veg(m)  = - f_qsws_veg  * ( qv1 - q_s                   &
                               + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
                               * surf_t_surface_p%var_1d(m) )
 
-          surf%qsws_soil_eb(m) = - f_qsws_soil * ( qv1 - q_s                   &
+          surf%qsws_soil(m) = - f_qsws_soil * ( qv1 - q_s                   &
                               + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
                               * surf_t_surface_p%var_1d(m) )
 
-          surf%qsws_liq_eb(m)  = - f_qsws_liq  * ( qv1 - q_s                   &
+          surf%qsws_liq(m)  = - f_qsws_liq  * ( qv1 - q_s                   &
                               + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
                               * surf_t_surface_p%var_1d(m) )
@@ -1564,5 +1657,5 @@
 !
 !--    Calculate the true surface resistance
-       IF ( surf%qsws_eb(m) == 0.0_wp )  THEN
+       IF ( .NOT.  humidity )  THEN
           surf%r_s(m) = 1.0E10_wp
        ELSE
@@ -1570,5 +1663,5 @@
                           * surf_t_surface%var_1d(m) - dq_s_dt *               &
                             surf_t_surface_p%var_1d(m) ) /                     &
-                            surf%qsws_eb(m) - surf%r_a(m)
+                            surf%qsws(m) - surf%r_a(m)
        ENDIF
 
@@ -1578,6 +1671,6 @@
        IF ( humidity )  THEN
 !
-!--       If precipitation is activated, add rain water to qsws_liq_eb
-!--       and qsws_soil_eb according the the vegetation coverage.
+!--       If precipitation is activated, add rain water to qsws_liq
+!--       and qsws_soil according the the vegetation coverage.
 !--       precipitation_rate is given in mm.
           IF ( precipitation )  THEN
@@ -1587,12 +1680,12 @@
 !--          Otherwise, add the water to soil. In case of
 !--          pavements, the exceeding water amount is implicitely removed 
-!--          as runoff as qsws_soil_eb is then not used in the soil model
-             IF ( surf_m_liq_eb%var_1d(m) /= m_liq_eb_max )  THEN
-                surf%qsws_liq_eb(m) = surf%qsws_liq_eb(m)                      &
+!--          as runoff as qsws_soil is then not used in the soil model
+             IF ( surf_m_liq%var_1d(m) /= m_liq_max )  THEN
+                surf%qsws_liq(m) = surf%qsws_liq(m)                      &
                                  + surf%c_veg(m) * prr(k+k_off,j+j_off,i+i_off)&
                                  * hyrho(k+k_off)                              &
                                  * 0.001_wp * rho_l * l_v
              ELSE
-                surf%qsws_soil_eb(m) = surf%qsws_soil_eb(m)                    &
+                surf%qsws_soil(m) = surf%qsws_soil(m)                    &
                                  + surf%c_veg(m) * prr(k+k_off,j+j_off,i+i_off)&
                                  * hyrho(k+k_off)                              &
@@ -1602,5 +1695,5 @@
 !--          Add precipitation to bare soil according to the bare soil
 !--          coverage.
-             surf%qsws_soil_eb(m) = surf%qsws_soil_eb(m) + ( 1.0_wp            &
+             surf%qsws_soil(m) = surf%qsws_soil(m) + ( 1.0_wp            &
                                - surf%c_veg(m) ) * prr(k+k_off,j+j_off,i+i_off)&
                                * hyrho(k+k_off)                                &
@@ -1610,48 +1703,50 @@
 !
 !--       If the air is saturated, check the reservoir water level
-          IF ( surf%qsws_eb(m) < 0.0_wp )  THEN
-!
-!--          Check if reservoir is full (avoid values > m_liq_eb_max)
-!--          In that case, qsws_liq_eb goes to qsws_soil_eb. In this 
-!--          case qsws_veg_eb is zero anyway (because c_liq = 1),       
+          IF ( surf%qsws(m) < 0.0_wp )  THEN
+!
+!--          Check if reservoir is full (avoid values > m_liq_max)
+!--          In that case, qsws_liq goes to qsws_soil. In this 
+!--          case qsws_veg is zero anyway (because c_liq = 1),       
 !--          so that tend is zero and no further check is needed
-             IF ( surf_m_liq_eb%var_1d(m) == m_liq_eb_max )  THEN
-                surf%qsws_soil_eb(m) = surf%qsws_soil_eb(m) + surf%qsws_liq_eb(m)
-
-                surf%qsws_liq_eb(m)  = 0.0_wp
+             IF ( surf_m_liq%var_1d(m) == m_liq_max )  THEN
+                surf%qsws_soil(m) = surf%qsws_soil(m) + surf%qsws_liq(m)
+
+                surf%qsws_liq(m)  = 0.0_wp
              ENDIF
 
 !
-!--          In case qsws_veg_eb becomes negative (unphysical behavior), 
+!--          In case qsws_veg becomes negative (unphysical behavior), 
 !--          let the water enter the liquid water reservoir as dew on the
 !--          plant
-             IF ( surf%qsws_veg_eb(m) < 0.0_wp )  THEN
-                surf%qsws_liq_eb(m) = surf%qsws_liq_eb(m) + surf%qsws_veg_eb(m)
-                surf%qsws_veg_eb(m) = 0.0_wp
+             IF ( surf%qsws_veg(m) < 0.0_wp )  THEN
+                surf%qsws_liq(m) = surf%qsws_liq(m) + surf%qsws_veg(m)
+                surf%qsws_veg(m) = 0.0_wp
              ENDIF
           ENDIF                    
  
-          tend = - surf%qsws_liq_eb(m) * drho_l_lv
-          surf_m_liq_eb_p%var_1d(m) = surf_m_liq_eb%var_1d(m) + dt_3d *        &
+          surf%qsws(m) = surf%qsws(m) / l_v
+ 
+          tend = - surf%qsws_liq(m) * drho_l_lv
+          surf_m_liq_p%var_1d(m) = surf_m_liq%var_1d(m) + dt_3d *        &
                                         ( tsc(2) * tend +                      &
-                                          tsc(3) * surf_tm_liq_eb_m%var_1d(m) )
+                                          tsc(3) * surf_tm_liq_m%var_1d(m) )
 !
 !--       Check if reservoir is overfull -> reduce to maximum
 !--       (conservation of water is violated here)
-          surf_m_liq_eb_p%var_1d(m) = MIN( surf_m_liq_eb_p%var_1d(m),m_liq_eb_max )
+          surf_m_liq_p%var_1d(m) = MIN( surf_m_liq_p%var_1d(m),m_liq_max )
 
 !
 !--       Check if reservoir is empty (avoid values < 0.0)
 !--       (conservation of water is violated here)
-          surf_m_liq_eb_p%var_1d(m) = MAX( surf_m_liq_eb_p%var_1d(m), 0.0_wp )
-!
-!--       Calculate m_liq_eb tendencies for the next Runge-Kutta step
+          surf_m_liq_p%var_1d(m) = MAX( surf_m_liq_p%var_1d(m), 0.0_wp )
+!
+!--       Calculate m_liq tendencies for the next Runge-Kutta step
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( intermediate_timestep_count == 1 )  THEN
-                surf_tm_liq_eb_m%var_1d(m) = tend
+                surf_tm_liq_m%var_1d(m) = tend
              ELSEIF ( intermediate_timestep_count <                            &
                       intermediate_timestep_count_max )  THEN
-                surf_tm_liq_eb_m%var_1d(m) = -9.5625_wp * tend +               &
-                                              5.3125_wp * surf_tm_liq_eb_m%var_1d(m)
+                surf_tm_liq_m%var_1d(m) = -9.5625_wp * tend +               &
+                                              5.3125_wp * surf_tm_liq_m%var_1d(m)
              ENDIF
           ENDIF
@@ -1684,5 +1779,5 @@
 !
 !-- Calculate new roughness lengths (for water surfaces only)
-    IF ( horizontal )  CALL calc_z0_water_surface
+    IF ( horizontal  .AND.  .NOT. constant_roughness )  CALL calc_z0_water_surface
 
     CONTAINS
@@ -1799,5 +1894,5 @@
        ENDIF
 
-       WRITE( io, 4 ) TRIM( veg_type_name(veg_type) ),                         &
+       WRITE( io, 4 ) TRIM( vegetation_type_name(vegetation_type) ),           &
                         TRIM (soil_type_name(soil_type) )
        WRITE( io, 5 ) TRIM( soil_depth_chr ), TRIM( t_soil_chr ),              &
@@ -1829,5 +1924,7 @@
     SUBROUTINE lsm_init
     
-
+       USE control_parameters,                                                 &
+           ONLY:  message_string
+    
        IMPLICIT NONE
 
@@ -1864,19 +1961,12 @@
        tt_soil_h_m%var_2d    = 0.0_wp
        tm_soil_h_m%var_2d    = 0.0_wp
-       tm_liq_eb_h_m%var_1d  = 0.0_wp
+       tm_liq_h_m%var_1d  = 0.0_wp
        surf_lsm_h%c_liq = 0.0_wp
 
-       surf_lsm_h%ghf_eb = 0.0_wp
-       surf_lsm_h%shf_eb = rho_cp * surf_lsm_h%shf
-
-       IF ( humidity )  THEN
-          surf_lsm_h%qsws_eb = rho_lv * surf_lsm_h%qsws
-       ELSE
-          surf_lsm_h%qsws_eb = 0.0_wp
-       ENDIF
-
-       surf_lsm_h%qsws_liq_eb  = 0.0_wp
-       surf_lsm_h%qsws_soil_eb = 0.0_wp
-       surf_lsm_h%qsws_veg_eb  = 0.0_wp
+       surf_lsm_h%ghf = 0.0_wp
+
+       surf_lsm_h%qsws_liq  = 0.0_wp
+       surf_lsm_h%qsws_soil = 0.0_wp
+       surf_lsm_h%qsws_veg  = 0.0_wp
 
        surf_lsm_h%r_a        = 50.0_wp
